﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;

namespace Naperstki
{
    public partial class Form1 : Form
    {
        Random r;
        bool start = false;
        int win, count = 0;
        int del = 3;
        public Form1()
        {
            InitializeComponent();
            r = new Random(DateTime.Now.Millisecond);
        }
        void down()
        {
            for(int i = 46; i < 200; i++)
            {
                cup1.Location = new Point(139,i);
                cup2.Location = new Point(361, i);
                cup3.Location = new Point(582, i);
                this.Refresh();
                Thread.Sleep(1);
            }
            coin.Visible = false;
        }
        void wining()
        { 
            while(coin.Left > 105) { coin.Left--; this.Refresh(); }
            while (coin.Top < 396) { coin.Top++; this.Refresh(); }
            count++;
            label1.Text = "Счёт: " + count.ToString();
            Thread.Sleep(900);
            coin.Visible = false;
            coin.Location = new Point(390, 240);
            coin.Visible = true;
            button4.Text = "CТАРТ";
        }
        void up()
        {
            coin.Visible = true;
            while(cup1.Top > 64) { cup1.Top--; cup2.Top--; cup3.Top--; if (cup1.Top % 8 == 0) this.Refresh(); }
        }
        void coinDraw(int pos)
        {
            switch (pos) { 
                case 139:
                    coin.Location = new Point(168, coin.Location.Y);
                    break;

                case 361:
                    coin.Location = new Point(390, coin.Location.Y);
                    break;

                case 582:
                    coin.Location = new Point(611, coin.Location.Y);
                    break;
            }
        }
        private void button4_Click(object sender, EventArgs e)
        {
            if (!start)
            {
                down();
                start = true;
                win = r.Next(1, 4);
                setup();
                
            }
        }
        void setup()
        {
            int a, b;
            int count_C = r.Next(6, 12);
            for (int i = 0; i < count_C; i++)
            {
                a = r.Next(1, 4); b = r.Next(1, 4); while (b == a) b = r.Next(1, 4);
                if ((a == 1 && b == 2) || (a == 2 && b == 1)) { change(cup1, cup2); }
                else if ((a == 1 && b == 3) || (a == 3 && b == 1)) { change(cup1, cup3); }
                else if ((a == 2 && b == 3) || (a == 3 && b == 2)) { change(cup3, cup2); }
                Thread.Sleep(70);

            }
        }
        private void cup1_Click(object sender, EventArgs e)
        {
            if (start)
            {
                coinDraw(cup2.Left);
                button4.Text = "ПРОИГРЫШ";
                up();
                Thread.Sleep(1000);
                coin.Visible = false;
                coinDraw(361);
                coin.Visible = true;
                button4.Text = "CТАРТ";
                start = false;
            }
        }

        private void cup2_Click(object sender, EventArgs e)
        {
            if (start)
            {  
                    coinDraw(cup2.Left);
                    up();
                    button4.Text = "ПОБЕДА";
                wining();
                button4.Text = "CТАРТ";
                start = false;
            }
        }

        private void cup3_Click(object sender, EventArgs e)
        {
            if (start)
            {
                    coinDraw(cup2.Left);
                    button4.Text = "ПРОИГРЫШ";
                    up();
                Thread.Sleep(1000);
                coin.Visible = false;
                coinDraw(361);
                coin.Visible = true;
                button4.Text = "CТАРТ";
                start = false;
            }
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            del = 3 - trackBar1.Value;
            switch (3 - trackBar1.Value)
            {
                case 0:
                    label2.Text = "Сложно";
                    break;
                case 1:
                    label2.Text = "Средне"; 
                    break;

                case 2:
                    label2.Text = "Легко";
                    break;
                    
            }
            count = 0;
            label1.Text = "Счёт: " + count.ToString();
        }

        void change(Button x, Button y)
        {
            int a = x.Location.X;
            int b = y.Location.X;
            if (a < b)
            {
                while (x.Left != b) { x.Left ++; y.Left--; Thread.Sleep(del); if(x.Left % 5 == 0) this.Refresh(); }
                    
            }
            else if(b < a)
            {
                while (y.Left != a) { y.Left ++; x.Left--; Thread.Sleep(del); if (y.Left % 5 == 0) this.Refresh(); }
            }
        }
    }
}
